<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <!--<div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-form :model="usePower">
        <el-form-item label="所属项目" :label-width="formLabelWidth">
          <span>{{this.projectName}}</span>
        </el-form-item>
        <el-form-item label="普通用户" :label-width="formLabelWidth" prop="content">
          <span v-if="this.userAstrict==0">不限制</span>
          <span v-if="this.userAstrict==1">限制观看 &nbsp {{this.userLimit}}页，每页10张图片</span>
        </el-form-item>
        <el-form-item label="VIP会员" :label-width="formLabelWidth" prop="content">
          <span v-if="this.vipAstrict==0">不限制</span>
          <span v-if="this.vipAstrict==1">限制观看 &nbsp {{this.vipLimit}}页，每页10张图片</span>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button class="filter-item" type="primary" icon="el-icon-edit" @click="handleEdit" v-permission="'/usePower/edit'">编辑</el-button>
      </div>
    </div>-->

    <div class="filter-container" style="margin: 10px 0 10px 0;" >
      <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
      <el-form-item label="项目">
        <el-select
          v-model="queryParams.projectUid"
          class="filter-item"
          placeholder="请选择"
          style="width: 140px"
          filterable
          clearable
          remote
          reserve-keyword
        >
          <el-option
            v-for="item in allProject"
            :key="item.uid"
            :label="item.name"
            :value="item.uid"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">查找</el-button>
      <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit">添加</el-button>
      </el-form>
      <!--<el-button class="filter-item" type="danger" @click="handleDeleteBatch" icon="el-icon-delete" v-permission="'/pictureTag/deleteBatch'">删除选中</el-button>-->
    </div>

    <el-table :data="tableData" style="width: 100%">
      <el-table-column label="项目名称" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.projectName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="普通用户是否限制" width="200" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.userAstrict==0">不限制</span>
          <span v-if="scope.row.userAstrict==1">限制观看</span>
        </template>
      </el-table-column>
      <el-table-column label="每个图集限制的图片数量" width="200" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.userLimit }}</span>
        </template>
      </el-table-column>

      <!--<el-table-column label="VIP是否限制" width="100" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.vipAstrict==0">不限制</span>
          <span v-if="scope.row.vipAstrict==1">限制观看</span>
        </template>
      </el-table-column>
      <el-table-column label="VIP限制多少页" width="160" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.vipLimit }}</span>
        </template>
      </el-table-column>-->

      <el-table-column label="操作" fixed="right" min-width="230">
        <template slot-scope="scope">
          <!--<el-button @click="handleEdit(scope.row)" type="primary" size="small" v-permission="'/pictureTag/edit'">编辑</el-button>-->
          <!--<el-button class="filter-item" type="primary" icon="el-icon-edit" @click="handleEdit(scope.row)" v-permission="'/usePower/edit'">编辑</el-button>-->
          <el-button class="filter-item" type="primary" icon="el-icon-edit" @click="handleEdit(scope.row)">编辑</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>

    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="dialogFormVisible" width="35%">
      <el-form :model="form" ref="form" >
        <el-form-item label="所属项目"  v-if="isEditForm" :label-width="formLabelWidth" >
          <span>{{form.projectName}}</span>
        </el-form-item>
        <el-form-item label="所属项目"  v-else :label-width="formLabelWidth" prop="projectUid">
          <el-select
            @input="projectContentChange"
            v-model="projectValue"
            size="small"
            placeholder="请选择"
            style="width: 80%"
            filterable
          >
            <el-option
              v-for="item in allProject"
              :key="item.uid"
              :label="item.name"
              :value="item.uid"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="普通用户" :label-width="formLabelWidth">
          <input type="radio" v-model="form.userAstrict" value="0" />不限制 &nbsp;
          <input type="radio" v-model="form.userAstrict" value="1" />限制观看 &nbsp; &nbsp;
          限制图片数量，每个图集<el-input v-model="form.userLimit" style="width:70px"></el-input>张图片
        </el-form-item>
        <!--<el-form-item label="VIP会员" :label-width="formLabelWidth">
          <input type="radio" v-model="form.vipAstrict" value="0" />不限制 &nbsp;
          <input type="radio" v-model="form.vipAstrict" value="1" />限制观看
          <el-input v-model="form.vipLimit" style="width:70px" ></el-input>页，每页10张图片
        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  addUsePower,
  editUsePower,
  getUsePowerList
} from "@/api/usePower";
import { initPorject } from "@/api/pictureSort";
import {getProjectList} from "@/api/project";
export default {
  data() {
    return {
      queryParams:{
        projectUid: null, //项目uid
      },
      projectUid: null, //项目uid
      projectName: null, //项目名称
      userAstrict: 0, //普通用户是否限制:0不限制；1限制
      userLimit: null, //普通用户限制页数
      vipAstrict: 0, //普通用户是否限制:0不限制；1限制
      vipLimit: null, //普通用户限制页数
      uid:null,
      multipleSelection: [], //多选，用于批量删除
      tableData: [],
      keyword: "",
      currentPage: 1,
      pageSize: 10,
      total: 0, //总数量
      title: "增加标签",
      dialogFormVisible: false, //控制弹出框
      formLabelWidth: "120px",
      isEditForm: false,
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
      usePower:{},
      allProject:[],
      projectValue: null, //保存选中项目id(编辑时)
      form: {
        userAstrict: "",
        userLimit: 0,
        vipAstrict: "",
        vipLimit: 0,
      }
    };
  },
  created() {
    this.usePowerList();
    this.getAllProject();
  },
  methods: {
    /*projectObj: function() {
      var tagParams = {};
      tagParams.pageSize = 500;
      tagParams.currentPage = 1;
      initPorject().then(response => {
        this.projectUid = response.data.uid;
        this.projectName = response.data.name;
        this.getUsePower();
      });
    },*/

    getUsePower: function() {
      var params = {};
      params.projectUid = this.projectUid;
      params.currentPage = this.currentPage;
      params.pageSize = this.pageSize;
      params.orderByDescColumn = this.orderByDescColumn
      params.orderByAscColumn = this.orderByAscColumn
      getUsePower(params).then(response => {
        this.userAstrict = response.data.userAstrict;
        this.userLimit = response.data.userLimit;
        this.vipAstrict = response.data.vipAstrict;
        this.vipLimit = response.data.vipLimit;
        this.uid = response.data.uid;
      });
    },
    handleFind: function() {
      this.currentPage = 1
      this.usePowerList();
    },
    usePowerList: function() {
      var params = {};
      params.projectUid = this.queryParams.projectUid;
      params.currentPage = this.currentPage;
      params.pageSize = this.pageSize;
      params.orderByDescColumn = this.orderByDescColumn
      params.orderByAscColumn = this.orderByAscColumn
      getUsePowerList(params).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        content: null,
        clickCount: 0,
        sort: 0
      };
      return formObject;
    },
    handleAdd: function() {
      this.title = "增加使用权限"
      this.dialogFormVisible = true;
      this.form = this.getFormObject();
      this.isEditForm = false;
    },
    handleEdit: function(row) {
      this.title = "编辑使用权限";
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.form = row;
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log('校验失败')
          return;
        } else {
          console.log("新增编辑参数="+JSON.stringify(this.form))

          if (this.isEditForm){
            editUsePower(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.usePowerList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          }else {
            addUsePower(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.usePowerList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          }


        }
      })
    },
    getAllProject: function() {
      var tagParams = {};
      tagParams.pageSize = 500;
      tagParams.currentPage = 1;
      getProjectList(tagParams).then(response => {
        if(response.data) {
          this.allProject = response.data.records;
        }
      });
    },
    projectContentChange: function() {
      this.form.projectUid = this.projectValue;
    },
    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.usePowerList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.usePowerList();
    },
  }
};
</script>
